#ifndef OmGSourceExtractionParamters_h
#define OmGSourceExtractionParameters_h
#include <qapplication.h>
#include <qdialog.h>
#include <qstring.h>
#include <qcheckbox.h>
//#include "OmSourceBrowser.h"
#include <qdatetime.h>
class QSpinBox;

class OmSourceLabel;;
class OmSourceButton;
class QProcess;
class QTextEdit;
class QComboBox;
class OmSourceGroupBox;

class ExtractionParameters
{
    public: 
        int _extractionMode;
        int _spectrumSmoothLength;
        int _binSize;
        int _plotFlux;
        bool _scaleBkgPlot;
        int _extractionRegionWidth;
        int _leftBkgOffset, _leftBkgWidth;
        int _rightBkgOffset, _rightBkgWidth;
     
        ExtractionParameters() : 
            _extractionMode(0), 
            _spectrumSmoothLength(0), 
            _binSize(3), 
            _plotFlux(2),
            _scaleBkgPlot(false) {};
	~ExtractionParameters() {};
         ExtractionParameters(ExtractionParameters  &parameters)
        {
	    _extractionMode = parameters._extractionMode;
            _spectrumSmoothLength = parameters._spectrumSmoothLength;
            _binSize = parameters._binSize;
            _plotFlux = parameters._plotFlux;
            _scaleBkgPlot = parameters._scaleBkgPlot;
            _extractionRegionWidth = parameters._extractionRegionWidth;
            _leftBkgOffset = parameters._leftBkgOffset;
            _leftBkgWidth = parameters._leftBkgWidth;
            _rightBkgOffset = parameters._rightBkgOffset;
            _rightBkgWidth = parameters._rightBkgWidth;






      };         

};   

class ExtractionParametersDlg : public QDialog
{
    Q_OBJECT
      signals:
    void information();
     
 private slots:
    void setExtractionMode(int value) {_extractionParameters->_extractionMode = value;  };
    void setSpectrumSmoothLength(int value) {_extractionParameters->_spectrumSmoothLength = value;  };
    void setBinSize(int value) {_extractionParameters->_binSize = value;  };
    void setPlotFlux(int value) {_extractionParameters->_plotFlux = value;  };
    void setScaleBkgPlot(bool value) {_extractionParameters->_scaleBkgPlot = value;  };
    void information1();    

      public:
   

    ~ExtractionParametersDlg();
  
  ExtractionParametersDlg(QWidget *parent, ExtractionParameters *parameters = 0);
  
   ExtractionParameters* getParameters() {return  _extractionParameters;};   
 
 private:

    ExtractionParameters* _extractionParameters;
     
};
#endif



