#ifndef OmSourceDetectDialog_h
#define OmSourceDetectDialog_h
#include <qapplication.h>
#include <qdialog.h>
#include <qstring.h>
#include <qcheckbox.h>
#include "OmSourceBrowser.h"
#include <qdatetime.h>

class QSpinBox;

class OmSourceLabel;;
class OmSourceButton;
class QProcess;
class QTextEdit;
class QComboBox;
class QTime;
class OmSourceGroupBox;
class QTimer;
class ExtractionRegion;
struct ExtractionParameters;
class OmgrismDlg : public QDialog
{
    Q_OBJECT
     
 private slots:
   

    void runOmgrism();    

    /*******************************************************************************
    *
    *
    *******************************************************************************/
    void runOmgrism(float centralWidth, 
                            float leftOffset, float leftWidth, 
		    float rightOffset, float rightWidth, int binSize);






    
    void finished();
    void finished1();
   
  
    void terminate(); 
   
    void slotDataOnStdout();
    void updateTime();

      public:
    OmgrismDlg(QWidget *parent, QString imageFile, 
                QString sourceListFile,    
                QString spectrumFile, 
                QString spectrumPlotFile,
                ExtractionRegion* region, 
                ExtractionParameters* parameters);


    
    OmgrismDlg(QWidget *parent, QString imageFile, 
                QString sourceListFile,    
                QString spectrumFile, 
                QString spectrumPlotFile,
	       float centralWidth,
	        float xOffset, float xWidth,
                float yOffset, float yWidth,
	       int binSize,
                ExtractionParameters* parameters);




 private:
    void runOmgrismPlot();






 
    QString _imageFile;
    QString _sourceListFile;
    QString _spectrumFile;
    QString _spectrumPlotFile;
    ExtractionRegion* _extractionRegion;
    ExtractionParameters* _extractionParameters;
    OmSourceLabel* _label;
    OmSourceLabel* _commandLabel;
   
 
    OmSourceButton* _terminateBtn;
   
 
    QProcess* _process;
    QTextEdit* _edit;
    QComboBox* _omgrismComboBox;
    QTime _time;  
    QTimer* _timer;
};
#endif

