// -*-C++-*-
//
// File:      OmSourceLog.cc
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Wed Oct  2 15:31:02 CEST 2002
// Usage:     -
// Info:      -

#include "OmSourceLog.h"
#include "OmSourceParameters.h"
#include <qstring.h>
#include <qtooltip.h>
#include <qheader.h>
/*****************************************************
*
*****************************************************/
OmSourceLog::OmSourceLog(QWidget* parent, const char* name) : QTable(parent, name)
{
    int noColumns = 7;

    setReadOnly(true);   // Can only read the table
    setSelectionMode(QTable::SingleRow);
    setNumCols( noColumns);
    setNumRows(1);

    
    QHeader *th = this->horizontalHeader();
 
    th->setLabel(0,"Aperture");
 

    th->setLabel(1,"Inner Bgr");
 
    th->setLabel(2,"Outer Bgr");
  

    th->setLabel(3,"Magnitude");
 

    th->setLabel(4,"Mag error");
 

    th->setLabel(5,"Significance");
 

    th->setLabel(6,"Coinc corr");
 



        setText(0, 0,"Aperture");

        setText(0, 1,"Inner Bgr");
 
        setText(0, 2,"Outer Bgr");
  

        setText(0, 3,"Magnitude");
 

        setText(0, 4,"Mag error");
 

        setText(0, 5,"Significance");
 

        setText(0, 6,"Coinc corr");
 

    /********************************************
    * Adjust the size of the cells
    *******************************************/
    for (int i = 0; i < noColumns; i++)
    {   
      
        setColumnWidth(i, text(0, i).length() * 7);


    }
    setNumRows(0);
    
}
/*****************************************************
*
*****************************************************/
OmSourceLog::~OmSourceLog()
{
}
/*****************************************************
*
*****************************************************/
void OmSourceLog::add(const OmSourceParameter& s)
{
    int rowNo = numRows();

    setNumRows(rowNo + 1);
    int colNo = 0;

    QString text;
   
					

    if (s.photometryradius == 0.0)

        setText(rowNo, colNo++, "extended");
             

    else
        setText(rowNo, colNo++, text.sprintf("%2d", int(s.photometryradius)));
    



    setText(rowNo, colNo++, text.sprintf("%2d", int(s.innerbackgroundradius)));
    setText(rowNo, colNo++, text.sprintf("%2d", int(s.outerbackgroundradius)));

    setText(rowNo, colNo++,  text.sprintf("%5.2f", s.magnitude));
    setText(rowNo, colNo++,  text.sprintf("%5.2f", s.magnitudeerror));


    setText(rowNo, colNo++, text.sprintf("%.1f", s.significance));

    setText(rowNo, colNo++, text.sprintf("%.1f", s.coincidencecorrection));




    QToolTip::add( this , QString("This is the source-list table\n") +
		          QString("It stores various paramters for each source\n") +
			  QString("Column 1 = aperture radius\n") +
			  QString("Column 2 = inner background annulus radius\n") +
			  QString("Column 3 = outer background annulus radius\n") +
			  QString("Column 4 = instrumental magnitude\n") +
			  QString("Column 5 = instrumental magnitude error\n") +
			  QString("Column 6 = significance\n") +
                          QString("Column 7 = coincidence-loss correction"));







}
/*****************************************************
*
*****************************************************/
QString OmSourceLog::getLine(const int index)
{
    QString line;
    for (int i = 0; i < numCols(); i++)
        line += text(index, i) + " ";

    return line;
}
/*****************************************************
*
*****************************************************/
void OmSourceLog::restart()
{
    setNumRows(0);
}
















