#ifndef OmSourceTableDlg_h
#define OmSourceTableDlg_h
#include <qapplication.h>
#include <qdialog.h>

#include "OmSourcePrint.h"
#include <vector>

class QTable;
class OmSourceButton;
class QPrinter;
class QPainter;
class QFontMetrics;
class  QPaintDeviceMetrics;
class ExtractionRegion;
class spectrumRegion;

class TableDlg : public QDialog, OmSourcePrint
{
    Q_OBJECT
public:


         
private slots:
    
    void selectionChanged(int row, int col);
    void deleteList();
    void printTable();

    void displaySpectrum( int no );


 signals:
    void selectionChanged(int row);
    void deleteSourceList();

    
public:
    TableDlg(QWidget *parent,  vector<spectrumRegion>* extractionRegionList);

    void Print(QPrinter* printer, QPainter* p,  
			 QFontMetrics* fm,  QPaintDeviceMetrics* metrics);


 private:
   
   
    void updateTable(spectrumRegion* extractionRegion);

    QTable *_table;

    OmSourceButton*     _printSourceListBtn;
    OmSourceButton*     _deleteListBtn;




};

#endif



