#include "utility.h"
#include <iostream>
#include <cmath>
#include <string>
/**********************************************
 * int Locate                                 *
 **********************************************/
//template <class kind1, class kind2, class kind3>
int Locate(float *xx, int n, float  x, int jl)
{
    if (n == 1) return 0;
    if (xx[0] > x) return 0;
    if (xx[n - 1] < x) return n - 1;

    int ju, jm;
    
    ju = n - 1;
    
    while (ju - jl > 1) {
      jm = (ju + jl) >> 1;
      if (xx[jm] < x)
          jl = jm;
      else
          ju = jm;
    }
    return jl;

};



/***********************************************
 * Initialise
 **********************************************/
template <class kind1, class kind2>
void  Initialise(kind1 *arrayPtr, kind2 size, kind1 value = 0.0)
{
   
    for (kind2 i = 0; i < size; i++) 
      *arrayPtr++ = value;
   
    
}

/********************************************
 * Allocate
 *******************************************/
template <class kind>
void Deallocate(kind ***array, int nRows)
{
    for (int i = 0; i < nRows; i++)
      if ((*array)[i]) delete [] (*array)[i];

    delete [] *array;
}
 

/***********************************
 * Random number generator         *
 ***********************************/
#define IA 16807
#define IM 2147483647
#define AM (1.0/IM)
#define IQ 127773
#define IR 2836
#define NTAB 32
#define NDIV (1+(IM-1)/NTAB)
#define EPS 1.2e-7
#define RNMX (1.0-EPS)

float Random()
{
    static long idum = -1;
    int j;
    long k;
    static long iy = 0;
    static long iv[NTAB];
    float temp;

    if (idum <=0 || !iy) {
      if (-idum < 1) idum = 1;
      else idum = -idum;
      for (j = NTAB + 7; j >= 0; j--) {
	k = idum / IQ;
        idum = IA * (idum - k * IQ) - IR * k;
        if (idum < 0) idum += IM;
        if (j < NTAB) iv[j] = idum;
      }
      iy = iv[0];
    }
    k = idum / IQ;
    idum = IA * (idum - k * IQ) - IR * k;
    if (idum < 0) idum += IM;
    j = iy / NDIV;
    iy = iv[j];
    iv[j] = idum;
    if ((temp = AM * iy) > RNMX) return RNMX;
    else return temp;
};
/**************************************
 * Maximum
 *************************************/
//template <class kind>
int Maximum(int a, int b)
{
  return (a > b) ? a : b;

}
/************************************
 * Minimum
 ***********************************/
//template <class kind>
int Minimum(int a, int b)
{
  return (a < b) ? a : b;

}


/***********************************************
 * Mimimum
 **********************************************/
template <class kind1, class kind2>
kind1 Minimum(kind1 *arrayPtr, kind2 size)
{
  
    kind1 min = *arrayPtr++;
    for (kind2 i = 1; i < size; i++)
      min = :: Minimum(min, *arrayPtr++);
    
 


    return min;
}
/***********************************************
 * Mamimum
 **********************************************/
template <class kind1, class kind2>
kind1 Maximum(kind1 *arrayPtr, kind2 size)
{
    kind1 max = *arrayPtr++;
    for (kind2 i = 1; i < size; i++)
      max = ::Maximum(max, *arrayPtr++);
    
    return max;
}
/***********************************************
 * Sum
 **********************************************/
template <class kind1, class kind2>
double Sum(kind1 *arrayPtr, kind2 size)
{
    double sum = *arrayPtr++;
    for (kind2 i = 1; i < size; i++) 
      sum += *arrayPtr++;
   
    return sum;
}

/*********************************************
 * class Lagrange * Interpolation
 *******************************************/
template<class kind>
Lagrange<kind>::Lagrange(int nIn, kind xIn[], kind yIn[])
{
  x = NULL;
  y = NULL;
  SetData(nIn, xIn, yIn);    

};
/***********************************************************
 * SetData
 ***********************************************************/
template <class kind>
void Lagrange<kind>::SetData(int nIn, kind xIn[], kind yIn[])
{
    n = nIn;
    if (x) delete [] x;
    if (y) delete [] y;
    x = new kind[n];
    y = new kind[n];
   
    for (int i = 0; i < n; i++)
    {
        x[i] = xIn[i];
        y[i] = yIn[i];
    }

}
/**************************************************
 * Interpolate
 *************************************************/
template<class kind> 
kind Lagrange<kind>::Interpolate(kind xa)
{
    if (xa < x[0] || xa > x[n - 1])
    {
        cout << "WARNING: x is in the extrapolation range\n";
       
    }
    kind yans = 0.0;
    for (int i = 0; i < n; i++)
    {
        kind z = 1.0;
        for (int j = 0; j < n; j++)
	{
	  if (i != j) z = z * (xa - x[j]) / (x[i] - x[j]);
        }
        yans = yans + z * y[i];
    }
    return yans;    

}
/**********************************************
 * GasDev - Returns a random Gaussian deviate
 *********************************************/
float Gasdev()
{
    static int iset = 0;
    static float gset;
    float fac, rsq, v1, v2;
    if (iset == 0) { 
        do {
	    v1 = 2.0 * Random() - 1.0;
            v2 = 2.0 * Random() - 1.0;
            rsq= v1 * v1 + v2 * v2;
        } while (rsq >= 1.0 || rsq == 0.0);
        fac = sqrt(-2.0 * log(rsq) / rsq);
        gset = v1 * fac;
        gset = v1 * fac;
        iset = 1;
        return v2 * fac;
    } else {
        iset = 0;
        return gset;
    }
}





